//+------------------------------------------------------------------+
//|                                                  Testing_DLL.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

struct STRUCT_DATA
  {
   int               i;
   double            d;
   bool              b;
   datetime          dt;
  };

#import "dll_mql5.dll"
void MsgBox(void);
void MessageBox(void);
string GetStringBuffer(void);
void SetString(string &a);
string SetParam(int &i,double d,bool b,datetime &dt);
string SetStruct(STRUCT_DATA &data);
string SetArray(int &arr[],int len);
string SetOptional(int &a,int b=0);
int DrawLRLine(double &rates,int len);
#import

//----------------------------------+
void OnStart()
//----------------------------------+
  {
   int i,len;
   double d;
   bool b;
   datetime dt;
   string s;
   STRUCT_DATA data;
   int arr[12];

//----------------------------------+
// 1. Call of procedure
//----------------------------------+
   MsgBox();
// If the names of the DLL functions coincide with the names of the MQL5 standard library functions,  
// when calling up a DLL function, it is vital to indicate the name of the DLL.   
   dll_mql5::MessageBox();

//----------------------------------+
// 2.Working with simple data types
//----------------------------------+

// initialization of variables
   i = 5;
   d = 2.8;
   b = true;
   dt= D'05.05.2010 08:31:27';
// calling the function
   s=SetParam(i,d,b,dt);
// output of result
   printf("%s i=%s d=%s b=%s dt=%s",s,IntegerToString(i),DoubleToString(d),b?"true":"false",TimeToString(dt));

//----------------------------------+
// 3.Working with structure
//----------------------------------+
   data.i = 5;
   data.d = 2.8;
   data.b = true;
   data.dt= D'05.05.2010 08:31:27';
   s=SetStruct(data);
   printf("%s i=%s d=%s b=%s dt=%s",s,IntegerToString(data.i),DoubleToString(data.d),
          data.b?"true":"false",TimeToString(data.dt));

//----------------------------------+
// 4.Working with an array
//----------------------------------+
   len=ArraySize(arr);
   s=SetArray(arr,len);

// output of result
   for(int i=0; i<len; i++)
      s=s+" "+IntegerToString(arr[i]);
   printf(s);

//----------------------------------+
// 5.1.Working with a string using the Windows API style
//----------------------------------+
// the string should be initialized before the use
// the buffer size should be greater or equal to the length of the string
   StringInit(s,255,0); 
// the string buffer is passed to DLL by reference
   SetString(s);
// output of result
   printf(s);

//----------------------------------+
// 5.2.Working with a string. String buffer in DLL.
//----------------------------------+
   s=GetStringBuffer();
   printf(s);

//----------------------------------+
// 6.Working with default parameters
//----------------------------------+
   i=1;
   s=SetOptional(i); // the second parameter is optional
   printf(s);

  }
//+------------------------------------------------------------------+
